/**
 * @name suns.js
 * @author Kazuma MISHIMAGI <mishimagi_kazuma@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview Object extending utilities for node and browser (amd support)
 */

/**
 * @name bucks.js
 * @author Kazuma MISHIMAGI <mishimagi_kazuma@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview Async chain utility for node and the browser. (amd support)
 */

/**
 * @name logcafe.js
 * @author Kei Funagayama <funagayama_kei@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview browser logging.
 */

/**
 * @license beez Copyright (c) Cyberagent Inc.
 * Available via the MIT License.
 */

!function(t){var e=Array.prototype.forEach,r={},n=function(t,n,i){if(void 0!==t&&null!==t)if(e&&t.forEach===e)t.forEach(n,i);else if(t.length===+t.length){for(var o=0,s=t.length;s>o;o++)if(n.call(i,t[o],o,t)===r)return}else for(var u in t)if(Object.prototype.hasOwnProperty.call(t,u)&&n.call(i,t[u],u,t)===r)return},i=function(t){return n(Array.prototype.slice.call(arguments,1),function(e){for(var r in e)t[r]=e[r]}),t},o=/__(super)+__/,s=function(t,e,r){var n;if("object"!=typeof r)throw new Error("typeof childCtorOrProto invalid. it should be Object (prototype object).");n=r&&Object.prototype.hasOwnProperty.call(r,"constructor")?r.constructor:new Function("parent","return function "+t+"(){ parent.apply(this, arguments); };")(e),i(n,e);var s=function(){this.constructor=n};s.prototype=e.prototype,n.prototype=new s,r&&i(n.prototype,r);for(var u in e)if(o.test(u)){var a=u.replace("super","supersuper");n[a]=e[u]}return n.__super__=e.prototype,n.__superCtor__=e,n},u=function p(t,e,r){if(r.length<1)return e;var n=r.shift(),i=s(t,e,n);return p(t,i,r)},a=function(t){var e="",r=Array.prototype.slice.apply(arguments);return"string"==typeof r[0]&&(e=r.shift(),e=e.replace(/\./g,"_")),t=r.shift(),u(e,t,r)},c=function(){var t=this,e=Array.prototype.slice.apply(arguments),r=[];return"string"==typeof e[0]&&r.push(e.shift()),r.push(t),r=r.concat(e),a.apply(this,r)},l=function(t,e,r){var n,s,u=typeof r;if("function"===u)s=r.prototype;else{if("object"!==u)throw new Error("typeof childCtorOrProto invalid. it should be Function or Object.");s=r}n="function"===u?new Function("parent, childCtor","return function "+t+"(){ parent.apply(this, arguments); childCtor.apply(this, arguments)};")(e,r):s&&Object.prototype.hasOwnProperty.call(s,"constructor")?s.constructor:new Function("parent","return function "+t+"(){ parent.apply(this, arguments); };")(e),i(n,e);var a=function(){this.constructor=n};a.prototype=e.prototype,n.prototype=new a,s&&i(n.prototype,s);for(var c in e)if(o.test(c)){var l=c.replace("super","supersuper");n[l]=e[c]}return n.__super__=e.prototype,n.__superCtor__=e,n},h=function g(t,e,r){if(r.length<1)return e;var n=r.shift(),i=l(t,e,n);return g(t,i,r)},f=function(t){var e="",r=Array.prototype.slice.apply(arguments);return"string"==typeof r[0]&&(e=r.shift(),e=e.replace(/\./g,"_")),t=r.shift(),h(e,t,r)},d={extend:a,extendThis:c,mixin:f,VERSION:"0.4.6"};"function"==typeof define&&define.amd?define("beez-core/suns",["require","exports","module"],function(){return d}):"undefined"!=typeof module&&module.exports?module.exports=d:t.suns=d}(this),function(){define("beez-core/error",["require","exports","module","beez-core/suns"],function(t){var e=t("beez-core/suns"),r=e.extend("beez.Error",Error,{constructor:function(t){Error.apply(this,arguments),Error.captureStackTrace(this,this.constructor),this.message=t}});return r.extend=e.extendThis,r})}(this),function(t){var e=function(){},r=Array.isArray||function(t){return"[object Array]"===t.toString()},n=function(t){return 0===t.length},i=function(t){t.stack?console.error(t.stack):t.message?console.error(t.message):console.error(t)},o=0,s=function(){return"__bucks__"+o++},u=function c(t){this._tasks=[],this._taskcount=0,this._results=[],this.callback=e,this.failure=e,this._alive=!0,this.__id=s(),c.living[this.__id]=this,this.initialize(t)};u.VERSION="0.8.2",u.DEBUG=!1,u.running={},u.living={},u._isOnError=!1,u.onError=function l(l){!function(t){u._onError=l,u._isOnError=t}(!0)},u.prototype={initialize:e,_normalizeTask:function(t){var e=t;if(t.length<3)e=function(e,r,n){var i=t.call(null,e,r);n.call(null,null,i)};else if(3===t.length)e=t;else{if(4!==t.length)throw new Error("args length invalid");e=function(e,r,n,i){t.call(null,e,r,n,i)}}return e},_normalizeSuccess:function(t){var e=t;if(t.length<2)e=function(e,r){var n=t(e);r(null,n)};else{if(2!==t.length)throw new Error("args length invalid");e=t}return e},_normalizeError:function(t){var e=t;if(t.length<2||3<t.length)throw new Error(t.name+": args length invalid. should be: onError(err, next)");return e},add:function(t){if(!this._alive)throw new Error("this bucks object already destroyed.");var e=this._normalizeTask(t);return this._tasks.push(e),this},then:function(t){var e=this._normalizeSuccess(t);return this.add(function(t,r,n){t?n(t):e(r,n)})},empty:function(){return this.then(function(){})},error:function(t){var e=this._normalizeError(t);return this.add(function(t,r,n){t?e(t,n):n(t,r)})},_iterator:function(t,e){if(!this._alive)throw new Error("this bucks object already destroyed.");e?this._results.push(e):this._results.push(null);var r=this._tasks.shift();if(!r)return this.destroy(t);try{var n=this;r(t,e,function(t,e){return n._iterator(t,e),this},this._taskcount++)}catch(o){if(!this._results){if(u.DEBUG&&i(o),!u._isOnError)throw o;u._onError(o,this)}this._iterator(o,null)}return this},debug:function(){return this},parallel:function(t){if(!r(t))throw new Error("tasks is not array.");if(n(t))return this.add(function(t,e,r){r(null,new a(0).resultObj)});for(var e=0,i=t.length;i>e;e++){var o=t[e];t[e]=this._normalizeTask(o)}return this.add(function(e,r,n){var i=new a(t.length);i.onFinish(function(t){for(var e,r=0,i=t.err.length;i>r;r++){var o=t.err[r];void 0!==o&&null!==o&&(e=o)}n(e,t)}),t.forEach(function(t,e){setTimeout(function(){(new u).add(t).end(function(t,r){t?i.successOne(e,t,null):i.successOne(e,null,r[0])})},0)})})},waterfall:function(t){if(!r(t))throw new Error("tasks is not array.");if(n(t))return this.add(function(t,e,r){r(null,[])});for(var e=0,i=t.length;i>e;e++)t[e]=this._normalizeTask(t[e]),this.add(t[e]);return this},delay:function(t){return this.add(function(e,r,n){setTimeout(function(){n(e,r)},t||0)})},dispose:e,destroy:function(t){if(!this._alive)return this;var r=this._results,n=this.callback,o=this.failure,s=this.dispose;this._tasks=null,this._taskcount=0,this._results=null,this.callback=e,this.failure=e,this.dispose=e,r.shift();try{if(n)n(t,r);else if(t)throw t}catch(a){if(o)try{o(a)}catch(c){if(!u._isOnError)throw c;u._onError(c,this)}else{if(u.DEBUG&&i(a),!u._isOnError)throw a;u._onError(a,this)}}finally{try{s.call(this)}catch(c){if(!u._isOnError)throw c;u._onError(c,this)}delete this._alive,delete u.running[this.__id],delete u.living[this.__id],delete this.__id}return this},end:function(t,e){if(t&&t.length<1)throw new Error("callback args length invalid. should be `callback(err, ress)` or `callback(err)`.");if(this.callback=t,this.failure=e,!this._tasks||!this._tasks.length){var r=new Error("task is empty. add(task) first. if theres no task to execute but end is desired, empty() may be useful");return this.destroy(r,null),t(r)}return u.running[this.__id]=this,this._iterator(),void 0}};var a=function(t){this._results=[],this._errors=[],this._waiting=t};a.prototype={onFinish:function(t){this._onFinish=t},successOne:function(t,e,r){this._errors[t]=e,this._results[t]=r,this._waiting--,this._waiting<=0&&this._onFinish.call(null,this.resultObj)}},a.prototype.__defineGetter__("resultObj",function(){return{err:this._errors,res:this._results}}),"function"==typeof define&&define.amd?define("beez-core/bucks",["require","exports","module"],function(){return u}):"undefined"!=typeof module&&module.exports?module.exports=u:t.Bucks=u}(this),function(t){var e=function(){},r=function(t,e){this.initialize(t,e)};r.prototype={initialize:function(t,r){this.category=t,this.config=r,this.level=this.config.level,this.config.separator&&(this.separator=this.config.separator||" "),this.level===this.LEVELS.TRACE||(this.level===this.LEVELS.DEBUG?this.trace=e:this.level===this.LEVELS.INFO?this.trace=this.debug=e:this.level===this.LEVELS.WARN?this.trace=this.debug=this.info=e:this.level===this.LEVELS.ERROR&&(this.trace=this.debug=this.info=this.warn=e))},LEVELS:{OFF:"OFF",TRACE:"TRACE",DEBUG:"DEBUG",INFO:"INFO",WARN:"WARN",ERROR:"ERROR"},_exclude:function(){if(this.config.excludes&&0<this.config.excludes.length)for(var t=0;t<this.config.excludes.length;t++){var e=new RegExp("^"+this.config.excludes[t]);if(this.category.match(e))return!0}return!1},trace:function(){!this._exclude()&&console.debug(this.output("trace",arguments))},debug:function(){!this._exclude()&&console.debug(this.output("debug",arguments))},info:function(){!this._exclude()&&console.info(this.output("info",arguments))},warn:function(){!this._exclude()&&console.warn(this.output("warn",arguments))},error:function(){!this._exclude()&&console.error(this.output("error",arguments))},output:function(t,e){for(var r=Array.prototype.slice.call(e),n=0;n<r.length;n++)if(void 0===r[n])r[n]='"undefined"';else if(null===r[n])r[n]='"null"';else if(r[n]instanceof Error||"Error"===r[n].constructor.name){var i=r[n];r[n]=i.stack?i.stack:i.message}else"object"==typeof r[n]&&(r[n]=r[n].constructor.name+":"+JSON.stringify(r[n]));var o,s,u,a="",c=(new Error).stack;return c&&(o=c.split("\n"),o[3]?(s=o[3],u=s.indexOf("("),u>=0?(a=s.substring(u),")"!==a.charAt(a.length-1)&&(a="("+a+")")):a="("+s.replace(/[ ]*at /,"")+")"):o[2]&&(s=o[2],u=s.indexOf("@"),u>=0&&(a=s.substring(u+1),a=" ("+a+")"))),"["+t+"]["+this.category+"] "+r.join(this.separator)+" "+a}};var n=function(t){this.initialize(t)};n.prototype={initialize:function(t){this.config=t,this.loggers={}},setConfigure:function(t){return this.config=t,this},getLogger:function(t){return this.loggers[t]?this.loggers[t]:(this.loggers[t]=new r(t,this.config),this.loggers[t])}},n.VERSION="0.6.7","function"==typeof define&&define.amd?define("beez-core/logcafe",["require","exports","module"],function(){return n}):"undefined"!=typeof module&&module.exports?module.exports=n:t.LogCafe=n}(this),function(t){define("beez.core",["require","exports","module","beez-core/suns","beez-core/error","beez-core/bucks","beez-core/logcafe","backbone","handlebars"],function(e,r,n){var i=t;if(i.beez)return i.beez;var o=e("beez-core/suns"),s=n.config()||{},u=e("beez-core/error"),a=e("beez-core/bucks");a.extend=o.extendThis;var c=e("beez-core/logcafe"),l=new c;l.setConfigure(s.logging||{level:"WARN",separator:" "});var h=function(t){return l.getLogger(t)},f=h("beez.core.index"),d=function(e,r,n){e&&(t.onerror=e),r&&a.onError(r),n&&(t.require.onError=n)},p={};if(s.defines&&(p=s.defines,p.globals))for(var g in p.globals)t[g]=p.globals[g],f.debug("Set the value to the global scope.",g,":",t[g]);var _={vendor:{},root:i,global:i,config:s,defines:p,none:function(){},extend:o.extend,extendThis:o.extendThis,mixin:o.mixin,getLogger:h,onError:d,Error:u,Bucks:a};return _.vendor._=_.root._,_.vendor.$=_.root.$,_.vendor.Backbone=e("backbone"),_.vendor.Handlebars=e("handlebars"),i.beez=_,_})}(this);